'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _pullToRefresh = require('antd-mobile/lib/pull-to-refresh');

var _pullToRefresh2 = _interopRequireDefault(_pullToRefresh);

var _listView = require('antd-mobile/lib/list-view');

var _listView2 = _interopRequireDefault(_listView);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

require('antd-mobile/lib/pull-to-refresh/style/css');

require('antd-mobile/lib/list-view/style/css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

require('./styles/ListView.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// 滚动数据
var scrollData = {};
// pageSize
/**
 * 基础列表组件
 */
var pageSize = 15;
// 延迟时间
var time = 500;
// 拉动距离限制, 建议小于 200
var damping = 60;
// 控制在滚动过程中，scroll事件被调用的频率
var scrollEventThrottle = 500;
// 调用onEndReached之前的临界值，单位是像素
var onEndReachedThreshold = 100;

var ListView = function (_React$Component) {
  (0, _inherits3.default)(ListView, _React$Component);

  function ListView(props) {
    (0, _classCallCheck3.default)(this, ListView);

    var _this = (0, _possibleConstructorReturn3.default)(this, (ListView.__proto__ || Object.getPrototypeOf(ListView)).call(this, props));

    _this.onScroll = function (e) {
      var id = _this.props.id;

      scrollData[id] = e.target.scrollTop;
    };

    _this.state = {
      size: pageSize,
      refreshing: false
    };
    return _this;
  }

  (0, _createClass3.default)(ListView, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var _props = this.props,
          list = _props.list,
          id = _props.id;

      if (!this.props.location) {
        return;
      }
      var action = this.props.location.action;

      if (action === 'PUSH') {
        scrollData[id] = 0;
        this.setState({
          size: pageSize
        }, function () {
          _this2.refs[id].scrollTo(0, 0);
        });
      }
      if (action === 'POP') {
        this.setState({
          size: list.length
        }, function () {
          _this2.refs[id].scrollTo(0, scrollData[id]);
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      // 父组件提供的props
      var _props2 = this.props,
          list = _props2.list,
          renderRow = _props2.renderRow,
          renderSeparator = _props2.renderSeparator,
          refreshing = _props2.refreshing,
          hasMoreData = _props2.hasMoreData,
          refresh = _props2.refresh,
          endRefresh = _props2.endRefresh,
          renderHeader = _props2.renderHeader,
          id = _props2.id,
          className = _props2.className;
      // 定义dataSource

      var dataSource = new _listView2.default.DataSource({
        rowHasChanged: function rowHasChanged(row1, row2) {
          return row1 !== row2;
        }
      });

      // 下拉刷新属性配置
      var refreshProps = {};
      if (refresh) {
        refreshProps = {
          pullToRefresh: _react2.default.createElement(_pullToRefresh2.default, { refreshing: refreshing || this.state.refreshing,
            damping: damping,
            onRefresh: function onRefresh() {
              setTimeout(function () {
                refresh();
              }, time);
            }
          })
        };
      }

      // 上拉刷新属性配置
      var endRefreshProps = {};
      if (endRefresh) {
        endRefreshProps = {
          onEndReachedThreshold: onEndReachedThreshold,
          onEndReached: function onEndReached() {
            endRefresh();
          },
          renderFooter: function renderFooter() {
            return _react2.default.createElement(
              'div',
              { className: 'zk_slight-tip' },
              hasMoreData ? '' : '没有更多记录'
            );
          }
        };
      }
      //间隔修饰
      var separator = function separator(sectionID, rowID) {
        return _react2.default.createElement('div', {
          key: sectionID + '-' + rowID,
          className: renderSeparator || 'zk_separator'
        });
      };
      var isUseBody = this.props.useBodyScroll ? this.props.useBodyScroll : false;
      return _react2.default.createElement(_listView2.default, (0, _extends3.default)({
        renderHeader: renderHeader,
        dataSource: dataSource.cloneWithRows(list),
        renderRow: renderRow,
        renderSeparator: separator,
        useBodyScroll: isUseBody,
        style: {
          height: isUseBody ? document.documentElement.clientHeight : this.props.height,
          overflow: 'auto',
          width: '100%'
        },
        className: className,
        ref: id,
        pageSize: this.state.size,
        initialListSize: this.state.size,
        onScroll: function onScroll(e) {
          return _this3.onScroll(e);
        },
        scrollEventThrottle: scrollEventThrottle
      }, refreshProps, endRefreshProps));
    }
  }]);
  return ListView;
}(_react2.default.Component);

ListView.propTypes = {
  // 列表标识
  id: _propTypes2.default.string.isRequired,
  // 容器高度
  height: _propTypes2.default.number,
  // 是否使用 html 的 body 作为滚动容器
  useBodyScroll: _propTypes2.default.bool,
  // 列表头部标题
  renderHeader: _propTypes2.default.func,
  // 列表数据
  list: _propTypes2.default.array.isRequired,
  //样式类名称
  className: _propTypes2.default.string,
  // 返回每一条数列表的数据以及自定义样式
  renderRow: _propTypes2.default.func.isRequired,
  // 每一条之间分割物
  renderSeparator: _propTypes2.default.string,
  // 以下2个配合实现下拉刷新
  //下拉刷新回调函数
  refresh: _propTypes2.default.func,
  //是否显示刷新状态
  refreshing: _propTypes2.default.bool,
  // 以下2个配合实现上拉加载更多数据
  //是否有数据
  hasMoreData: _propTypes2.default.bool.isRequired,
  //上拉回调函数
  endRefresh: _propTypes2.default.func.isRequired
};

exports.default = ListView;
//# sourceMappingURL=ListView.js.map