'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _textareaItem = require('antd-mobile/lib/textarea-item');

var _textareaItem2 = _interopRequireDefault(_textareaItem);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

require('antd-mobile/lib/textarea-item/style/css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Header = require('../../Header/Header');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BaseTextareaEditable = function (_Component) {
  (0, _inherits3.default)(BaseTextareaEditable, _Component);

  function BaseTextareaEditable() {
    (0, _classCallCheck3.default)(this, BaseTextareaEditable);
    return (0, _possibleConstructorReturn3.default)(this, (BaseTextareaEditable.__proto__ || Object.getPrototypeOf(BaseTextareaEditable)).apply(this, arguments));
  }

  (0, _createClass3.default)(BaseTextareaEditable, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          title = _props.title,
          rows = _props.rows,
          type = _props.type,
          count = _props.count,
          value = _props.value,
          placeholder = _props.placeholder;

      var newTitle = title && type === 'column' ? title : '';
      return _react2.default.createElement(
        'div',
        { className: 'zk_basetextareaeditable' },
        title && type !== 'column' ? _react2.default.createElement(_Header.Header, { title: title, padding: '15px 15px 0', bgColor: '#fff' }) : '',
        _react2.default.createElement(_textareaItem2.default, (0, _extends3.default)({}, this.props, {
          title: newTitle,
          placeholder: placeholder || '请输入',
          editable: true,
          clear: true,
          value: value,
          rows: rows ? rows : 5,
          count: count ? count : 200
        }))
      );
    }
  }]);
  return BaseTextareaEditable;
}(_react.Component); /* 长文本组件 */


var BaseTextareaNoEdit = function (_Component2) {
  (0, _inherits3.default)(BaseTextareaNoEdit, _Component2);

  function BaseTextareaNoEdit() {
    (0, _classCallCheck3.default)(this, BaseTextareaNoEdit);
    return (0, _possibleConstructorReturn3.default)(this, (BaseTextareaNoEdit.__proto__ || Object.getPrototypeOf(BaseTextareaNoEdit)).apply(this, arguments));
  }

  (0, _createClass3.default)(BaseTextareaNoEdit, [{
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          rows = _props2.rows,
          value = _props2.value,
          type = _props2.type,
          title = _props2.title;

      var newTitle = title && type === 'column' ? title : '';
      return _react2.default.createElement(
        'div',
        { className: 'zk_basetextareanoedit' },
        title && type !== 'column' ? _react2.default.createElement(_Header.Header, { title: title, padding: '15px 15px 0', color: '#8e8e8e', size: 'middle',
          bgColor: '#fff' }) : '',
        _react2.default.createElement(_textareaItem2.default, (0, _extends3.default)({}, this.props, {
          title: newTitle,
          editable: false,
          value: value,
          rows: rows ? rows : 2
        }))
      );
    }
  }]);
  return BaseTextareaNoEdit;
}(_react.Component);

var BaseTextarea = function (_Component3) {
  (0, _inherits3.default)(BaseTextarea, _Component3);

  function BaseTextarea() {
    (0, _classCallCheck3.default)(this, BaseTextarea);
    return (0, _possibleConstructorReturn3.default)(this, (BaseTextarea.__proto__ || Object.getPrototypeOf(BaseTextarea)).apply(this, arguments));
  }

  (0, _createClass3.default)(BaseTextarea, [{
    key: 'render',
    value: function render() {
      var editable = this.props.editable;

      return _react2.default.createElement(
        'div',
        { className: 'zk_basetextarea' },
        editable ? _react2.default.createElement(BaseTextareaEditable, this.props) : _react2.default.createElement(BaseTextareaNoEdit, this.props)
      );
    }
  }]);
  return BaseTextarea;
}(_react.Component);

exports.default = BaseTextarea;


BaseTextarea.propTypes = {
  type: _propTypes2.default.oneOf(['row', 'column']),
  title: _propTypes2.default.string,
  editable: _propTypes2.default.bool,
  autoHeight: _propTypes2.default.bool,
  rows: _propTypes2.default.number,
  count: _propTypes2.default.number,
  placeholder: _propTypes2.default.string,
  value: _propTypes2.default.string
};
//# sourceMappingURL=BaseTextarea.js.map