import React, { Component } from 'react'
import PropTypes from 'prop-types'
import { Button, WhiteSpace, WingBlank } from 'antd-mobile'
import './Result.scss'
const SuccessIcon = require('./images/success.png')
const FailIcon = require('./images/fail.png')

class Result extends Component {
  showSpaces=(num) => {
    let spaces = []
    for (let i = 0; i < num; i++) {
      spaces.push(<WhiteSpace size='xl' />)
    }
    return spaces
  }

  mainButton = (onClick, onClickText) => {
    return onClick ? <div className={'zk_btn_group'}>
      <Button inline type='primary' onClick={() => onClick()}>{onClickText || '确认'}</Button></div> : ''
  }
  extraButton = (extraClick, extraClickText) => {
    return extraClick ? <div className={'zk_btn_group'}>
      <Button inline type='ghost' onClick={() => extraClick()}>{extraClickText || '返回首页'}</Button></div> : ''
  }

  render () {
    const { type, icon, title, content, onClick, onClickText, extraClick, extraClickText } = this.props
    let defaultIcon = type === 'fail' ? FailIcon : SuccessIcon
    return (
      <div className='zk_result_bg'>
        <WingBlank>
          <div className='zk_result-hd'>
            <img src={icon || defaultIcon} />
            <div className='zk_result-title'>
              {title}
            </div>
            <div className='zk_result-info'>
              {content}
            </div>
          </div>
          {this.showSpaces(7)}
          {this.mainButton(onClick, onClickText)}
          {this.extraButton(extraClick, extraClickText)}
        </WingBlank>
      </div>
    )
  }
}

Result.propTypes = {
  type: PropTypes.string,
  icon: PropTypes.string,
  title: PropTypes.string,
  content: PropTypes.string,
  onClick: PropTypes.func,
  onClickText: PropTypes.string,
  extraClick: PropTypes.string,
  extraClickText: PropTypes.func,
}

export default Result
